searchNodes=[{"doc":"Image processing in Nx . All functions expect images to be tensors in either HWC or CHW order, with an arbitrary number of leading batch axes. All transformations preserve the input type, rounding if necessary. For higher precision, cast the input to floating-point beforehand.","ref":"NxImage.html","title":"NxImage","type":"module"},{"doc":"Crops an image at the center. If the image is too small to be cropped to the desired size, it gets padded with zeros. Options :channels - channels location, either :first or :last . Defaults to :last Examples iex&gt; image = Nx . iota ( { 4 , 4 , 1 } , type : :u8 ) iex&gt; NxImage . center_crop ( image , { 2 , 2 } ) # Nx.Tensor &lt; u8 [ 2 ] [ 2 ] [ 1 ] [ [ [ 5 ] , [ 6 ] ] , [ [ 9 ] , [ 10 ] ] ] &gt; iex&gt; image = Nx . iota ( { 2 , 2 , 1 } , type : :u8 ) iex&gt; NxImage . center_crop ( image , { 1 , 4 } ) # Nx.Tensor &lt; u8 [ 1 ] [ 4 ] [ 1 ] [ [ [ 0 ] , [ 0 ] , [ 1 ] , [ 0 ] ] ] &gt;","ref":"NxImage.html#center_crop/3","title":"NxImage.center_crop/3","type":"function"},{"doc":"Converts values from continuous range into pixel values (0-255). Examples iex&gt; image = Nx . tensor ( [ [ [ 0.0 ] , [ 0.5 ] ] , [ [ 0.75 ] , [ 1.0 ] ] ] ) iex&gt; NxImage . from_continuous ( image , 0.0 , 1.0 ) # Nx.Tensor &lt; u8 [ 2 ] [ 2 ] [ 1 ] [ [ [ 0 ] , [ 128 ] ] , [ [ 191 ] , [ 255 ] ] ] &gt; iex&gt; image = Nx . tensor ( [ [ [ - 1.0 ] , [ 0.0 ] ] , [ [ 0.5 ] , [ 1.0 ] ] ] ) iex&gt; NxImage . from_continuous ( image , - 1.0 , 1.0 ) # Nx.Tensor &lt; u8 [ 2 ] [ 2 ] [ 1 ] [ [ [ 0 ] , [ 128 ] ] , [ [ 191 ] , [ 255 ] ] ] &gt;","ref":"NxImage.html#from_continuous/3","title":"NxImage.from_continuous/3","type":"function"},{"doc":"Normalizes an image according to the given per-channel mean and standard deviation. :channels - channels location, either :first or :last . Defaults to :last Examples iex&gt; image = Nx . iota ( { 2 , 2 , 3 } , type : :f32 ) iex&gt; mean = Nx . tensor ( [ 0.485 , 0.456 , 0.406 ] ) iex&gt; std = Nx . tensor ( [ 0.229 , 0.224 , 0.225 ] ) iex&gt; NxImage . normalize ( image , mean , std ) # Nx.Tensor &lt; f32 [ 2 ] [ 2 ] [ 3 ] [ [ [ - 2.1179039478302 , 2.4285714626312256 , 7.084444522857666 ] , [ 10.982532501220703 , 15.821427345275879 , 20.41777801513672 ] ] , [ [ 24.08296775817871 , 29.214284896850586 , 33.7511100769043 ] , [ 37.183406829833984 , 42.607139587402344 , 47.08444595336914 ] ] ] &gt;","ref":"NxImage.html#normalize/4","title":"NxImage.normalize/4","type":"function"},{"doc":"Resizes an image. Options :method - the resizing method to use, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bilinear :channels - channels location, either :first or :last . Defaults to :last Examples iex&gt; image = Nx . iota ( { 2 , 2 , 1 } , type : :u8 ) iex&gt; NxImage . resize ( image , { 3 , 3 } , method : :nearest ) # Nx.Tensor &lt; u8 [ 3 ] [ 3 ] [ 1 ] [ [ [ 0 ] , [ 1 ] , [ 1 ] ] , [ [ 2 ] , [ 3 ] , [ 3 ] ] , [ [ 2 ] , [ 3 ] , [ 3 ] ] ] &gt; iex&gt; image = Nx . iota ( { 2 , 2 , 1 } , type : :f32 ) iex&gt; NxImage . resize ( image , { 3 , 3 } , method : :bilinear ) # Nx.Tensor &lt; f32 [ 3 ] [ 3 ] [ 1 ] [ [ [ 0.0 ] , [ 0.5 ] , [ 1.0 ] ] , [ [ 1.0 ] , [ 1.5 ] , [ 2.0 ] ] , [ [ 2.0 ] , [ 2.5 ] , [ 3.0 ] ] ] &gt;","ref":"NxImage.html#resize/3","title":"NxImage.resize/3","type":"function"},{"doc":"Scales an image such that the short edge matches the given size. Options :method - the resizing method to use, same as resize/2 :channels - channels location, either :first or :last . Defaults to :last Examples iex&gt; image = Nx . iota ( { 2 , 4 , 1 } , type : :u8 ) iex&gt; resized_image = NxImage . resize_short ( image , 3 , method : :nearest ) iex&gt; Nx . shape ( resized_image ) { 3 , 6 , 1 } iex&gt; image = Nx . iota ( { 4 , 2 , 1 } , type : :u8 ) iex&gt; resized_image = NxImage . resize_short ( image , 3 , method : :nearest ) iex&gt; Nx . shape ( resized_image ) { 6 , 3 , 1 }","ref":"NxImage.html#resize_short/3","title":"NxImage.resize_short/3","type":"function"},{"doc":"Converts pixel values (0-255) into a continuous range. Examples iex&gt; image = Nx . tensor ( [ [ [ 0 ] , [ 128 ] ] , [ [ 191 ] , [ 255 ] ] ] ) iex&gt; NxImage . to_continuous ( image , 0.0 , 1.0 ) # Nx.Tensor &lt; f32 [ 2 ] [ 2 ] [ 1 ] [ [ [ 0.0 ] , [ 0.501960813999176 ] ] , [ [ 0.7490196228027344 ] , [ 1.0 ] ] ] &gt; iex&gt; image = Nx . tensor ( [ [ [ 0 ] , [ 128 ] ] , [ [ 191 ] , [ 255 ] ] ] ) iex&gt; NxImage . to_continuous ( image , - 1.0 , 1.0 ) # Nx.Tensor &lt; f32 [ 2 ] [ 2 ] [ 1 ] [ [ [ - 1.0 ] , [ 0.003921627998352051 ] ] , [ [ 0.49803924560546875 ] , [ 1.0 ] ] ] &gt;","ref":"NxImage.html#to_continuous/3","title":"NxImage.to_continuous/3","type":"function"},{"doc":"Mix . install ( [ { :nx , &quot;~&gt; 0.5.0&quot; } , { :nx_image , &quot;~&gt; 0.1.1&quot; } , { :kino , &quot;~&gt; 0.8.0&quot; } ] )","ref":"examples.html","title":"Examples","type":"extras"},{"doc":"Using a Livebook v0.8.0 or higher, we can add the new Kino.Input.image/1 to upload an image to our notebook. image_input = Kino.Input . image ( &quot;Uploaded Image&quot; ) We can use Input.read/1 to retrieve the information about our image. %{ data : content , format : _ , height : height , width : width } = Kino.Input . read ( image_input ) NxImage requires that the images be tensors in either HWC (default) or CHW order, with an arbitrary number of leading batch axes. The input data is already HWC, so creating a tensor is straightforward: image_tensor = Nx . from_binary ( content , :u8 ) |&gt; Nx . reshape ( { height , width , 3 } ) Now that we have a tensor in the shape of {height, width, channels} we operate on it using the NxImage module.","ref":"examples.html#upload-your-test-image","title":"Examples - Upload your test image","type":"extras"},{"doc":"The first capability we'll look at is center cropping. center_cropped_tensor = NxImage . center_crop ( image_tensor , { 300 , 300 } ) We've transformed the image from its original size to 300 x 300 by taking the pixels 150 above and below the image center. Similarly we have the 150 pixels to the left and right of the center point.","ref":"examples.html#center-crop","title":"Examples - Center crop","type":"extras"},{"doc":"Numbers are great, but most of us are visual focused. Let's see what center crop did to our uploaded image: Kino.Layout . grid ( [ Kino.Image . new ( center_cropped_tensor ) , Kino.Markdown . new ( &quot;**Center of the image**&quot; ) ] , boxed : true )","ref":"examples.html#visualization","title":"Examples - Visualization","type":"extras"},{"doc":"We'll resize the image. Whether this resized image is shrunk or enlarged is dependent upon the original image size. Resizing to a standard size can be useful when training visual models on a diverse set of source images. resized_tensor = NxImage . resize ( image_tensor , { 768 , 768 } , method : :nearest ) Let's display the original image and the resized image. If you can't tell the difference, try a non-square image, or resizing to a very small resolution instead. original_image = Kino.Image . new ( image_tensor ) original_label = Kino.Markdown . new ( &quot;**Original image**&quot; ) resized_image = Kino.Image . new ( resized_tensor ) resized_label = Kino.Markdown . new ( &quot;**Resized image**&quot; ) Kino.Layout . grid ( [ Kino.Layout . grid ( [ original_image , original_label ] , boxed : true ) , Kino.Layout . grid ( [ resized_image , resized_label ] , boxed : true ) ] ) Let's double check the shape of both images. { image_tensor . shape , resized_tensor . shape } We can see that the resized image has a different shape from the original image shape. You can try other resize strategies: :bilinear , :bicubic , :lanczos3 , :lanczos5 . How do they affect the resulting image?","ref":"examples.html#resize","title":"Examples - Resize","type":"extras"},{"doc":"There are other functions in the NxImage module. For example, NxImage.normalize/3 can be useful for transfer learning, where an original model is further trained on a set of images from your custom domain. The original images had a particular mean and standard deviation. When transfer learning from the base model, your source images are normalized in the same manner as the distribution of the original set of images. Note: in this notebook we were using the default Nx.BinaryBackend for all the operations. To speed up the operations you can configure an optimised backend or compiler, such as EXLA .","ref":"examples.html#further-exploration","title":"Examples - Further exploration","type":"extras"}]